<?php
# *********************** LICENSE *****************************************************	#
#	This file is part of EoleCAS plugin.
#
#	Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
#	Licence CeCill  cf /root/LicenceEole.txt
#	eole@ac-dijon.fr
# *************************************************************************************	#


/************************************************
*   EoleCAS plugin file		                   	*
*   Extension of CAS plugin file                *
*   from Jean-francois Rey                      *
*   jean-francois.rey@univ-avignon.fr           *
*   file: plugin_eolecas.php			        *
*   version: 2.00                           	*
*   date: 07/11/07                          	*
*   author : Gaston TJEBBES               	    *
*   email: g.tjebbes@ac-dijon.fr              	*
************************************************/

/*
 * name: plugin EOLECAS
 * description: Plugin CAS pour Envole (plugin EOLE). Attention !! Ce plugin n'est pas désactivable.
 * display:  style="font-weight:bolder;"
 * dependencies: no
 * author: Gaston TJEBBES
 * url: http://eole.orion.education.fr
 */
define("CAS_NAME","plugin EOLECAS");

include_once("configCAS/cas.inc.php");
include_once("cas.inc.php");
include_once("plugcas_tools.php");

include_once('CAS/eoleCAS.php');

if (__CAS_DEBUG){
    EolephpCAS::setDebug("/tmp/posh-cas.log");
}
// how to login
 register_hook("userinterface_header","plugcas_userinterface_header",1,1);
// how to login
 register_hook("admininterface_header","plugcas_userinterface_header",1,1);
// how to redirect after cas
 register_hook("userinterface_end","plugcas_userinterface_end",1,1);
// logout from cas server
 register_hook("logout","plugcas_logout");
// login form
 register_hook("display_login_form","plugcas_display_login_form",1);

function cas_return(){
    # construit l'url sur laquelle on renvoie
     $a = split(':',$_SERVER['SCRIPT_URI'],2);
    $protocol = $a[0];
    $return_url = $protocol."://".__CAS_RETURN;
    return $return_url;
}
function setLang(){
    if(__LANG=="fr"){
        EolephpCAS::setLang(PHPCAS_LANG_FRENCH);
    }else{
        EolephpCAS::setLang(PHPCAS_LANG_ENGLISH);
    }
}
function setNoCasServerValidation(){
    if (method_exists(EolephpCAS, 'setNoCasServerValidation')){
        EolephpCAS::setNoCasServerValidation();
    }
}
function initCasProxy(){
	EolephpCAS::proxy(__CAS_VERSION,__CAS_SERVER,__CAS_PORT,__CAS_FOLDER,false);
    setLang();
    setNoCasServerValidation();
}
function setLogoutHook(){
    if (is_file('/var/www/html/posh/includes/plugins/plugin_eolecas/logout.inc.php')){
            include('logout.inc.php');
    };
    echo "<script>";
    echo "var logout_urls=new Array();";
    foreach($LOGOUT_URLS as $logout_url){
    	echo "logout_urls.push('". $logout_url . "');";
    }
    echo "</script>";
    echo "<script type='text/javascript' src='../includes/plugins/plugin_eolecas/scripts/logout.js'></script>";
}


define('__LOGIN_PAGE', __CAS_PROTO . "://" . __CAS_SERVER . ":" . __CAS_PORT . __CAS_FOLDER . "/login");

// userinterface : first things are do! -> login
function plugcas_userinterface_header($page)
{
    setLogoutHook();
    echo "<link type='image/xicon' href='../images/eole_icone.ico' rel='shortcut icon' />";
    echo "<script type='text/javascript'>";
    // log to cas server
    if( __defaultAuthen=="cas" && $page=="portal/index.php" ){
    	// first connected
        // go to cas if not already went to cas
        $mylink = __LOGIN_PAGE . "?service=" . cas_return() ."/login.php";
        if(__defaultmode=="connected" && !isset($_REQUEST['ticket']) ){
            echo "$"."p.navigator.openLink('". $mylink . "');";
    	}else{ // default login send to cas

    		//login menu
            echo "function $"."p.app.connection.menu(){";
            echo " $"."p.navigator.openLink('" . $mylink . "');";
            echo "}";
            // Save menu!!
            $js_script  = "function $"."p.app.connection.saveMenu(){";
            $js_script .= "if (showBoxStatus){ hideBox(); }";
            $js_script .= "var l_s=\"<table><tr>\";";
            $js_script .= "l_s += \"<td valign=top width='400'>\";";
            $js_script .= "l_s += \"<div class='bottomhr'><b>\";";
            $js_script .= "l_s += lg(\"lblAccountCreation\");";
            $js_script .= "l_s += \" \" + __apname + \" :</b></div><br />\";\n";
            $js_script .= "l_s += \" :</b></div><br />\";\n";
            $url = __LOGIN_PAGE . "?service=". cas_return() ."/index.php?connect=firstsave";
            $js_script .= "l_s += \"<form name='form1' method='post' onsubmit=\\\"return link('" . $url . "');\\\">\";\n";
            $js_script .= "l_s+=\"<table cellspacing='0' cellpadding='0' border='0'>\"\n";
            $js_script .= "l_s+=\"<center><input class='btn' type='submit' name='\"+lg(\"lblOk\")+\"' style='width:250px' value='\"+lg(\"lblSavePage\")+\"' /></center>\"\n";
            $js_script .= "l_s+=\"</table></form><br />\";\n";
            $js_script .= "l_s+=\"</td><td width='50'></td><td valign='top' width='400'>\";";
            $js_script .= "l_s+=\"<div class='bottomhr'><b>\"+lg(\"lblAlreadyMember\")+\" ?</b></div>\";";
            $url = __LOGIN_PAGE . "?service=". cas_return() ."/index.php?connect=save";
            $js_script .= "l_s+=\"<form name='form2' method='post' onsubmit=\\\" return link('". $url ."');\\\">\";";
            $js_script .= "l_s+=\"<table cellspacing='0' cellpadding='0' border='0'>\";";
            $js_script .= "l_s+=\"<tr><td colspan='2' align='center'><br />\";";
            $js_script .= "l_s+=\"<input class='btn' type='submit' value='\"+lg(\"lblSavePage\")+\"' style='width:250px' />\";";
            $js_script .= "l_s+=\"</td></tr>\";";
            $js_script .= "l_s+=\"</table></form>\";";
            $js_script .= "l_s+=\"</td></tr></table>\";";
            $js_script .= "\$"."p.print(\"box\",box(0,img(\"ico_menu_disk.gif\",16,16,\"\",\"imgmid\")+\" \"+lg(\"lblSavePage\"),\"hideBox()\",l_s));\n";
            $js_script .= "\$"."p.show(\"box\",\"block\");";
            $js_script .= "showBoxStatus=true;\n";
            $js_script .= "return false;";
            $js_script .= "}";
            echo $js_script;
        }
    }elseif(__defaultAuthen == "cas" && ($page == "portal/login.php" || $page == "admin/login.php") && !isset($_REQUEST['ticket']) ){
        echo "$"."p.navigator.openLink('".__CAS_PROTO."://".__CAS_SERVER.":".__CAS_PORT.__CAS_FOLDER."/login?service=". cas_return() ."/login.php');";
    }
    // my profile menu when change user
    $js_script = "$" ."p.network.changeProfile = new Function( \"$";
    $js_script .= "p.navigator.openLink('".cas_return()."/scr_authentif.php?act=logout&from=change');\");";
    echo $js_script;
    echo "</script>";
}

// login.php
function plugcas_display_login_form(){
    initCasProxy();
    $is_auth = EolephpCAS::checkAuthentication();
    echo "<script type='text/javascript'>";
	if($is_auth){
		// ok go to user page
        $user = EolephpCAS::getUser();
        echo "var fcas = new Array();";
        echo "fcas.password = new Array();";
        echo "fcas.password.value=".random_number().";";
		echo "fcas.username = new Array(); fcas.username.value='".$user."';";
        echo "$"."p.app.connection.set(fcas,$"."p.app.pages.isPageExisting);";
	}else{
        echo "$"."p.navigator.openLink('".__CAS_PROTO."://".__CAS_SERVER.":".__CAS_PORT.__CAS_FOLDER."/login?service=". cas_return() ."/login.php');";
    }
    echo "$"."('loginbox').style.display = 'none'";
    echo "</script>";
}

// page index end
function plugcas_userinterface_end($page){
    // if went to cas server, got a ticket -> check it
    if( __defaultAuthen=="cas" && $page=="portal/index.php" && isset($_REQUEST['ticket'])){
        initCasProxy();
    	if(EolephpCAS::checkAuthentication()){
    		$user = EolephpCAS::getUser();
	    	echo "<script type='text/javascript'>";
		    echo "var fcas = new Array(); fcas.password = new Array(); fcas.password.value=".random_number().";";
    		echo "fcas.username = new Array(); fcas.username.value='".$user."';";
	    	echo "fcas.longname = new Array(); fcas.longname.value='';";
		    // link save
    		if(isset($_REQUEST['connect'])){
		    	//first connection
			    if( $_REQUEST['connect'] == "firstsave"){
                    $numpwd = random_number();
                    echo "fcas.pass = new Array();";
                    echo "fcas.pass.value=".$numpwd.";";
                    echo "fcas.confpass = new Array();";
                    echo "fcas.confpass.value=".$numpwd.";";
		    		echo "fcas.autoconn = new Array();";
			    	echo "$"."p.app.connection.subscribe(fcas,savePage);";
			    }else{// already connected
                    echo "$"."p.app.connection.set(fcas,savePage);";
                }

            }else{ // login
			echo "window.stop();";
			echo "$"."p_app.connection.set(fcas,link,true);";
    		}
	    	echo "</script>";
    	}
    }
}

// check authentication cas
if ( __defaultAuthen=="cas" && !function_exists('user_login_form') ):
// call by user_login
function user_login_form($username,$password,&$user,&$errormsg)
{
	global $DB,$authentif_getUserByName;
	launch_hook('user_login_form',$username,$password);
	//Check the password
	$DB->getResults($authentif_getUserByName,$DB->quote($username));
	if ($DB->nbResults()<=0)
	{
		$errormsg.=lg("incorrectLogin");
	}else{
		$row=$DB->fetch(0);
		if ($row["typ"]=="N" OR $row["typ"]=="M"){
			$errormsg.=lg("userNotValidated");
		}else{
            initCasProxy();
			if(EolephpCAS::isAuthenticated()){
				// ok go to user page
                $username = EolephpCAS::getUser();
			}else{
				$errormsg.=lg("incorrectLogin");
			}
        }
		if( $errormsg == "" ){
			$user->id=$row["id"];
			$user->username=$username;
			$user->type=$row["typ"];
			$user->lang=$row["lang"];
			$user->longname=$row["long_name"]==""?$username:$row["long_name"];
			$user->pass = md5($password);
			$DB->freeResults();
			return true;
		}
	}
	$DB->freeResults();
	return false;
}
endif;

// logout
function plugcas_logout(){
	if (__defaultAuthen=="cas"){
		if(isset($_GET["act"]) && $_GET["act"]=="logout" && $_GET["from"] != "A") { // not admin
            initCasProxy();
            // Logout effectif
            if (method_exists(phpCAS, 'logoutWithUrl')){
                EolephpCAS::logoutWithUrl(cas_return());
            }else{
                EolephpCAS::logout(cas_return());
            }
        }
    }
}
?>
